<?php
/**
 * Created by PhpStorm.
 * User: gerd
 * Date: 29.01.14
 * Time: 10:13
 */

/**Aufruf:
 * http://shopurl.tld/index.php?agws_it_recht_kanzlei=1
 **/

if ( verifyGPDataString('agws_it_recht_kanzlei') ==1 )
{

    require_once(PFAD_ROOT . PFAD_CLASSES . "class.JTL-Shop.Jtllog.php");
    require_once($oPlugin->cFrontendPfad  . "includes/func_agws_it_recht_kanzlei.php");

    // ----- Settings -----
    $agws_it_recht_kanzlei_local_api_version = '1.0'; 									// only change when told to do so
    $agws_it_recht_kanzlei_local_supported_rechtstext_types = array('agb','datenschutz','widerruf','impressum');				// only change when told to do so
    $agws_it_recht_kanzlei_local_supported_rechtstext_languages = array('de');			// only change when told to do so
    $agws_it_recht_kanzlei_local_supported_actions = array('push');						// only change when told to do so

    $agws_it_recht_kanzlei_local_rechtstext_pdf_required = array('agb' => false);			// true or false (set to true for each rechtstext type where you require a pdf-file)
    $agws_it_recht_kanzlei_local_dir_for_pdf_storage = PFAD_ROOT.'includes/plugins/agws_it_recht_kanzlei/version/pdf-dokumente/';								// directory where to store downloaded pdf-files, append with a slash, e.g. 'pdfs/'  - leave empty for pdf files being stored in same dir like this script
    $agws_it_recht_kanzlei_local_dir_for_pdf_storage_admin = PFAD_ROOT.PFAD_ADMIN.PFAD_INCLUDES.PFAD_EMAILPDFS;
    $agws_it_recht_kanzlei_local_limit_download_from_host = '';							//  only change when told to do so, this will limit pdf downloads to a specific source host. e.g. 'www.it-recht-kanzlei.de'
    $agws_it_recht_kanzlei_pdf_dl = $oPlugin->oPluginEinstellungAssoc_arr['cPDFDown'];
    $agws_it_recht_kanzlei_pdf_mail = $oPlugin->oPluginEinstellungAssoc_arr['cPDFMail'];
    $agws_it_recht_kanzlei_local_user_auth_token = $oPlugin->oPluginEinstellungAssoc_arr['cAPIToken'];

    $agws_it_recht_kanzlei_post_xml = $_POST['xml'];

    if(get_magic_quotes_gpc())
        $agws_it_recht_kanzlei_post_xml = stripslashes($agws_it_recht_kanzlei_post_xml);

    Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Rechtstext: " . $agws_it_recht_kanzlei_post_xml , JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);

    // Catch errors - no data sent
    if(trim($agws_it_recht_kanzlei_post_xml) == '')
        agws_it_recht_kanzlei_return_error('12',$oPlugin);

    // create xml object
    $agws_it_recht_kanzlei_xml = @simplexml_load_string($agws_it_recht_kanzlei_post_xml);

    // Catch errors - error creating xml object
    if($agws_it_recht_kanzlei_xml === false)
        agws_it_recht_kanzlei_return_error('12',$oPlugin);

    // Catch errors - action not supported
    if(($agws_it_recht_kanzlei_xml->action == '') OR (in_array($agws_it_recht_kanzlei_xml->action, $agws_it_recht_kanzlei_local_supported_actions) == false))
        agws_it_recht_kanzlei_return_error('10',$oPlugin);

    // Check api-version
    if($agws_it_recht_kanzlei_xml->api_version != $agws_it_recht_kanzlei_local_api_version)
        agws_it_recht_kanzlei_return_error('1',$oPlugin);

    //switch authentication-methode
    $agws_it_recht_kanzlei_auth_meth = 3; //we only use the api-token authentication

    switch ($agws_it_recht_kanzlei_auth_meth)
    {
        case 1:     // Check api authentication
            $agws_it_recht_kanzlei_local_api_username = 'testapiuser';							// enter desired api username and inform IT-Recht Kanzlei to send this username
            $agws_it_recht_kanzlei_local_api_password = 'testapipass';						// enter desired api password and inform IT-Recht Kanzlei to send this password

            if(($agws_it_recht_kanzlei_xml->api_username != $agws_it_recht_kanzlei_local_api_username) OR ($agws_it_recht_kanzlei_xml->api_password != $agws_it_recht_kanzlei_local_api_password))
                agws_it_recht_kanzlei_return_error('2',$oPlugin);

            break;

        case 2:     // user authentication w username/password (alternative to auth_token)
            $agws_it_recht_kanzlei_local_user_username = 'testuser'; // #### static demo username
            $agws_it_recht_kanzlei_local_user_password = 'testpass'; // #### static demo password

            if((strtolower($agws_it_recht_kanzlei_xml->user_username) != strtolower($agws_it_recht_kanzlei_local_user_username)) OR (strtolower($agws_it_recht_kanzlei_xml->user_password) != strtolower($agws_it_recht_kanzlei_local_user_password)))
                agws_it_recht_kanzlei_return_error('3',$oPlugin);

            break;

        case 3:    /// user authentication w token (alternative to auth username/password)
            if($agws_it_recht_kanzlei_xml->user_auth_token != $agws_it_recht_kanzlei_local_user_auth_token)
                agws_it_recht_kanzlei_return_error('3',$oPlugin);

            break;
    }

    switch ($agws_it_recht_kanzlei_xml->action)
    {
        case 'push':

            // Catch errors - rechtstext_type
            if(($agws_it_recht_kanzlei_xml->rechtstext_type == '') OR (in_array($agws_it_recht_kanzlei_xml->rechtstext_type, $agws_it_recht_kanzlei_local_supported_rechtstext_types) == false))
                agws_it_recht_kanzlei_return_error('4',$oPlugin);

            // Catch errors - rechtstext_text
            if(strlen($agws_it_recht_kanzlei_xml->rechtstext_text) < 50)
                agws_it_recht_kanzlei_return_error('5',$oPlugin);

            // Catch errors - rechtstext_html
            if(strlen($agws_it_recht_kanzlei_xml->rechtstext_html) < 50)
                agws_it_recht_kanzlei_return_error('6',$oPlugin);

            // Catch errors - rechtstext_language
            if(($agws_it_recht_kanzlei_xml->rechtstext_language == '') OR (in_array($agws_it_recht_kanzlei_xml->rechtstext_language, $agws_it_recht_kanzlei_local_supported_rechtstext_languages) == false))
                agws_it_recht_kanzlei_return_error('9',$oPlugin);

            //switch xml-lang to shop-lang
            switch ($agws_it_recht_kanzlei_xml->rechtstext_language)
            {
                case 'de':
                    $agws_it_recht_kanzlei_shop_lang="ger";
                    break;

                case 'gb':
                    $agws_it_recht_kanzlei_shop_lang="eng";
                    break;

                case 'fr':
                    $agws_it_recht_kanzlei_shop_lang="fre";
                    break;

                default:
                    $agws_it_recht_kanzlei_shop_lang="ger";
                    break;

            }

            $agws_it_recht_kanzlei_sprache = $GLOBALS['DB']->executeQuery("SELECT kSprache, cISO
                                                    FROM tsprache
                                                    WHERE cISO = '".$agws_it_recht_kanzlei_shop_lang."'", 1);

            if (!isset($agws_it_recht_kanzlei_sprache->kSprache) || $agws_it_recht_kanzlei_sprache->kSprache <= 0)
                $agws_it_recht_kanzlei_sprache = $GLOBALS['DB']->executeQuery("SELECT kSprache, cISO
                                                    FROM tsprache
                                                    WHERE cShopStandard = 'Y'", 1);


            //Download PDF-Files
            $file_pdf_target_rename = "-";

            if ($agws_it_recht_kanzlei_pdf_dl ==1 && $agws_it_recht_kanzlei_xml->rechtstext_type != 'impressum')
            {

                // Catch errors - element 'rechtstext_pdf_url' empty or URL invalid
                if(($agws_it_recht_kanzlei_xml->rechtstext_pdf_url == '') OR (agws_it_recht_kanzlei_url_valid($agws_it_recht_kanzlei_xml->rechtstext_pdf_url, $agws_it_recht_kanzlei_local_limit_download_from_host) !== true)){ agws_it_recht_kanzlei_return_error('7'); }

                // Download pdf file
                $file_pdf_targetfilename = md5(uniqid("")).'.pdf'; // #### adapt the created filename to your needs, if required
                $file_pdf_target = $agws_it_recht_kanzlei_local_dir_for_pdf_storage.$file_pdf_targetfilename;
                $file_pdf_targetfilename_rename = $agws_it_recht_kanzlei_xml->rechtstext_type."-".date("Y-m-d_H-i-s").".pdf";
                $file_pdf_target_rename = $agws_it_recht_kanzlei_local_dir_for_pdf_storage.$file_pdf_targetfilename_rename;

                $file_pdf = @fopen($file_pdf_target,"w+");
                if($file_pdf === false){ agws_it_recht_kanzlei_return_error('7',$oPlugin); } // catch errors

                //new in V200
                $file_content=http_get_contents($agws_it_recht_kanzlei_xml->rechtstext_pdf_url);
                if($file_content == ""){ agws_it_recht_kanzlei_return_error('7',$oPlugin); } // catch errors
                $retval = @fwrite($file_pdf, $file_content);
                //$retval = @fwrite($file_pdf, @file_get_contents($agws_it_recht_kanzlei_xml->rechtstext_pdf_url));


                if($retval === false){ agws_it_recht_kanzlei_return_error('7',$oPlugin); } // catch errors
                $retval = @fclose($file_pdf);
                if($retval === false){ agws_it_recht_kanzlei_return_error('7',$oPlugin); } // catch errors

                // Catch errors - downloaded file was not properly saved
                if(file_exists($file_pdf_target) !== true){ agws_it_recht_kanzlei_return_error('7',$oPlugin); }

                // verify that file is a pdf
                if(agws_it_recht_kanzlei_check_if_pdf_file($file_pdf_target) !== true){
                    unlink($file_pdf_target);
                    agws_it_recht_kanzlei_return_error('7',$oPlugin);
                }

                // verify md5-hash, delete file if hash is not equal
                if(md5_file($file_pdf_target) != $agws_it_recht_kanzlei_xml->rechtstext_pdf_md5hash){
                    unlink($file_pdf_target);
                    agws_it_recht_kanzlei_return_error('8',$oPlugin);
                }

                rename($file_pdf_target,$file_pdf_target_rename);

            }

                //Mail-Handling
            $agws_it_recht_kanzlei_MailID = $GLOBALS['DB']->executeQuery("SELECT kEmailvorlage
                                                FROM temailvorlage
                                                WHERE cModulId = '".MAILTEMPLATE_BESTELLBESTAETIGUNG."'", 1);

            if ($agws_it_recht_kanzlei_pdf_mail > 0 && ($agws_it_recht_kanzlei_xml->rechtstext_type != 'impressum' && $agws_it_recht_kanzlei_xml->rechtstext_type != 'datenschutz') )
            {
                $file_pdf_targetfilename_copy_admin = $agws_it_recht_kanzlei_xml->rechtstext_type."_".$agws_it_recht_kanzlei_sprache->kSprache.".pdf";
                $file_pdf_target_copy_admin = $agws_it_recht_kanzlei_local_dir_for_pdf_storage_admin.$file_pdf_targetfilename_copy_admin;


                if (!copy($file_pdf_target_rename, $file_pdf_target_copy_admin))
                   Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Error - PDF-Dokument Emailvorlage konnte nicht gespeichert werden", JTLLOG_LEVEL_ERROR, false, "kPlugin", $oPlugin->kPlugin);


                switch ($agws_it_recht_kanzlei_pdf_mail)
                {
                    case '1': //PDF-Datei

                        $GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nAGB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
                        $GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nWRB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);

                        $cPDFS_value = ";agb_".$agws_it_recht_kanzlei_sprache->kSprache.".pdf;widerruf_".$agws_it_recht_kanzlei_sprache->kSprache.".pdf;";

                        $cDateiname_value = ";agb_doc;widerruf_doc;";

                        $GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cPDFS = '".$cPDFS_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
                        $GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cDateiname = '".$cDateiname_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);

                        break;

                    case '2': // Mail-Text

                        $GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nAGB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
                        $GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nWRB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);

                        break;

                    case '3': // PDF-Datei & Mail-Text

                        $GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nAGB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
                        $GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nWRB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);

                        $cPDFS_value = ";agb_".$agws_it_recht_kanzlei_sprache->kSprache.".pdf;widerruf_".$agws_it_recht_kanzlei_sprache->kSprache.".pdf;";

                        $cDateiname_value = ";agb_doc;widerruf_doc;";

                        $GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cPDFS = '".$cPDFS_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
                        $GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cDateiname = '".$cDateiname_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);

                        break;
                }


            }elseif ($agws_it_recht_kanzlei_pdf_mail == 0 && ($agws_it_recht_kanzlei_xml->rechtstext_type != 'impressum' || $agws_it_recht_kanzlei_xml->rechtstext_type != 'datenschutz') )
            {
                $GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nAGB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
                $GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nWRB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
                $GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cPDFS = '' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
                $GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cDateiname = '' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);

            }

            $agws_it_recht_kanzlei_save = agws_it_recht_kanzlei_save($oPlugin,$agws_it_recht_kanzlei_xml,$agws_it_recht_kanzlei_sprache,$file_pdf_targetfilename_rename);

            if ($agws_it_recht_kanzlei_save===true)
                 agws_it_recht_kanzlei_return_success('0',$oPlugin);

            break;

    }


    agws_it_recht_kanzlei_return_error('99',$oPlugin);
    exit();
}
