<?php
/**
 * AGWS helper class for Plugins - Adminsection
 *
 */

/**
 * Class agwsPluginAdminHelper
 */
if (!class_exists('agwsPluginAdminHelper'))
{
    class agwsPluginAdminHelper
    {
        /**
         * @var null|agwsPluginAdminHelper
         */
        private static $_instance = null;

        /**
         * @var null|bool
         */
        private static $_isShop4 = null;

        /**
         * @var null|NiceDB
         */
        private $db = null;

        /**
         * @var null|Plugin
         */
        private $plugin = null;


        /**
         * constructor
         *
         * @param Plugin $oPlugin
         */
        public function __construct(Plugin $oPlugin)
        {
            $this->plugin = $oPlugin;
            //get database instance - do not do this, use Shop::DB()/$GLOBALS['DB'] instead
            if (self::isShop4()) {
                $this->db = Shop::DB();
            } else {
                $this->db = $GLOBALS['DB'];
            }
        }

        /**
         * singleton getter
         *
         * @param Plugin $oPlugin
         * @return agwsPluginAdminHelper
         */
        public static function getInstance(Plugin $oPlugin)
        {
            return (self::$_instance === null) ? new self($oPlugin) : self::$_instance;
        }


        /**
         * check if there is a current shop version installed
         *
         * @return bool
         */
        public static function isShop4()
        {
            if (self::$_isShop4 === null) {
                //cache the actual value as class variable
                self::$_isShop4 = version_compare(JTL_VERSION, 400, '>=') && class_exists('Shop');
            }

            return self::$_isShop4;
        }
    }
}