<?php
/**
 * Created by PhpStorm.
 * User: gerd
 * Date: 29.01.14
 * Time: 12:12
 */

    // return error and end script
    function agws_it_recht_kanzlei_return_error($errorcode,$Plugin)
    {
        //log error
        Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Error - errorcode: " . $errorcode , JTLLOG_LEVEL_ERROR, false, "kPlugin", $Plugin->kPlugin);

        $shopversion = substr(JTL_VERSION,0,1).".".substr(JTL_VERSION,1,2);

        if (defined('JTL_MINOR_VERSION'))
            $shopversion=$shopversion.".".JTL_MINOR_VERSION;

        $pluginversion = substr($Plugin->nVersion,0,1).".".substr($Plugin->nVersion,1,2);

        // output error
        header('Content-type: application/xml; charset=utf-8');
        echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
        echo "<response>\n";
        echo "	<status>error</status>\n";
        echo "	<error>".$errorcode."</error>\n";
        echo "	<meta_shopversion>".$shopversion."</meta_shopversion>\n";
        echo "	<meta_modulversion>".$pluginversion."</meta_modulversion>\n";
        echo "</response>";
        exit();
    }

    // return success and end script
    function agws_it_recht_kanzlei_return_success($errorcode,$Plugin)
    {
        //log success
        Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Success" , JTLLOG_LEVEL_DEBUG, false, "kPlugin", $Plugin->kPlugin);

        $shopversion = substr(JTL_VERSION,0,1).".".substr(JTL_VERSION,1,2);

        if (defined('JTL_MINOR_VERSION'))
            $shopversion=$shopversion.".".JTL_MINOR_VERSION;

        $pluginversion = substr($Plugin->nVersion,0,1).".".substr($Plugin->nVersion,1,2);

        // output success
        header('Content-type: application/xml; charset=utf-8');
        echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
        echo "<response>\n";
        echo "	<status>success</status>\n";
        echo "	<meta_shopversion>".$shopversion."</meta_shopversion>\n";
        echo "	<meta_modulversion>".$pluginversion."</meta_modulversion>\n";
        echo "</response>";
        exit();
    }


    // save new legal text and log
    function agws_it_recht_kanzlei_save($oPlugin,$agws_it_recht_kanzlei_xml,$agws_it_recht_kanzlei_sprache,$file_pdf_targetfilename_rename,$agws_it_recht_kanzlei_shop4)
    {
        // Logging systemlog - begin
        Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Neuer Rechtstext erhalten - Typ:  " . $agws_it_recht_kanzlei_xml->rechtstext_type, JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);

        $agws_it_recht_kanzlei_ContentHtml = iconv("UTF-8", "Windows-1252",$agws_it_recht_kanzlei_xml->rechtstext_html);
        $agws_it_recht_kanzlei_ContentText = iconv("UTF-8", "Windows-1252",$agws_it_recht_kanzlei_xml->rechtstext_text);

        $agws_it_recht_kanzlei_ContentHtml = ($agws_it_recht_kanzlei_shop4 === true) ? Shop::DB()->escape($agws_it_recht_kanzlei_ContentHtml) : $GLOBALS['DB']->escape($agws_it_recht_kanzlei_ContentHtml);
        $agws_it_recht_kanzlei_ContentText = ($agws_it_recht_kanzlei_shop4 === true) ? Shop::DB()->escape($agws_it_recht_kanzlei_ContentText) : $GLOBALS['DB']->escape($agws_it_recht_kanzlei_ContentText);

        $agws_it_recht_kanzlei_SpalteHtml    = "";
        $agws_it_recht_kanzlei_SpalteText    = "";
        $agws_it_recht_kanzlei_Tabelle   = "";
        $agws_it_recht_kanzlei_Set       = "";
        $agws_it_recht_kanzlei_Link      = 0;

        switch($agws_it_recht_kanzlei_xml->rechtstext_type)
        {
            // AGB
            case "agb":
                $agws_it_recht_kanzlei_SpalteHtml    = "cAGBContentHtml";
                $agws_it_recht_kanzlei_SpalteText    = "cAGBContentText";
                $agws_it_recht_kanzlei_Tabelle   = "ttext";
                $cWhere     = " kSprache = " . intval($agws_it_recht_kanzlei_sprache->kSprache);

                $agws_content_exists = ($agws_it_recht_kanzlei_shop4 === true)?
                    Shop::DB()->query("SELECT * FROM " . $agws_it_recht_kanzlei_Tabelle. " WHERE " . $cWhere, 1):
                    $GLOBALS['DB']->executeQuery("SELECT * FROM " . $agws_it_recht_kanzlei_Tabelle. " WHERE " . $cWhere, 1);

                if (!is_object($agws_content_exists)) {
                    $oTmpKundengruppe = ($agws_it_recht_kanzlei_shop4 === true)?
                        Shop::DB()->query("SELECT * FROM tkundengruppe WHERE cStandard = 'Y'", 1):
                        $GLOBALS['DB']->executeQuery("SELECT * FROM tkundengruppe WHERE cStandard = 'Y'", 1);

                    $oInsert = new stdClass();
                    $oInsert->kSprache = intval($agws_it_recht_kanzlei_sprache->kSprache);
                    $oInsert->kKundengruppe = intval($oTmpKundengruppe->kKundengruppe);
                    $oInsert->cAGBContentText = "";
                    $oInsert->cAGBContentHtml = "";
                    $oInsert->cWRBContentText = "";
                    $oInsert->cWRBContentHtml = "";
                    $oInsert->nStandard = 0;

                    ($agws_it_recht_kanzlei_shop4 === true)?
                        Shop::DB()->insertRow($agws_it_recht_kanzlei_Tabelle, $oInsert):
                        $GLOBALS['DB']->insertRow($agws_it_recht_kanzlei_Tabelle, $oInsert);
                }

                break;

            // WRB
            case "widerruf":
                $agws_it_recht_kanzlei_SpalteHtml    = "cWRBContentHtml";
                $agws_it_recht_kanzlei_SpalteText    = "cWRBContentText";
                $agws_it_recht_kanzlei_Tabelle   = "ttext";
                $cWhere     = " kSprache = " . intval($agws_it_recht_kanzlei_sprache->kSprache);

                $agws_content_exists = ($agws_it_recht_kanzlei_shop4 === true)?
                    Shop::DB()->query("SELECT * FROM " . $agws_it_recht_kanzlei_Tabelle. " WHERE " . $cWhere, 1):
                    $GLOBALS['DB']->executeQuery("SELECT * FROM " . $agws_it_recht_kanzlei_Tabelle. " WHERE " . $cWhere, 1);

                if (!is_object($agws_content_exists)) {
                    $oTmpKundengruppe = ($agws_it_recht_kanzlei_shop4 === true)?
                        Shop::DB()->query("SELECT * FROM tkundengruppe WHERE cStandard = 'Y'", 1):
                        $GLOBALS['DB']->executeQuery("SELECT * FROM tkundengruppe WHERE cStandard = 'Y'", 1);

                    $oInsert = new stdClass();
                    $oInsert->kSprache = intval($agws_it_recht_kanzlei_sprache->kSprache);
                    $oInsert->kKundengruppe = intval($oTmpKundengruppe->kKundengruppe);
                    $oInsert->cAGBContentText = "";
                    $oInsert->cAGBContentHtml = "";
                    $oInsert->cWRBContentText = "";
                    $oInsert->cWRBContentHtml = "";
                    $oInsert->nStandard = 0;

                    ($agws_it_recht_kanzlei_shop4 === true)?
                        Shop::DB()->insertRow($agws_it_recht_kanzlei_Tabelle, $oInsert):
                        $GLOBALS['DB']->insertRow($agws_it_recht_kanzlei_Tabelle, $oInsert);
                }

                break;

            // Impressum
            case "impressum":
                $agws_it_recht_kanzlei_SpalteHtml    = "cContent";
                $agws_it_recht_kanzlei_SpalteText    = "";
                $agws_it_recht_kanzlei_Tabelle   = "tlinksprache";
                $agws_it_recht_kanzlei_Link      = ($agws_it_recht_kanzlei_shop4 === true) ? Shop::DB()->query("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_IMPRESSUM, 1) : $GLOBALS['DB']->executeQuery("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_IMPRESSUM, 1);
                $cWhere     = "cISOSprache = '" . gibSprachKeyISO("", $agws_it_recht_kanzlei_sprache->kSprache) . "' AND kLink = " . $agws_it_recht_kanzlei_Link->kLink;

                $agws_content_exists = ($agws_it_recht_kanzlei_shop4 === true)?
                    Shop::DB()->query("SELECT * FROM " . $agws_it_recht_kanzlei_Tabelle. " WHERE " . $cWhere, 1):
                    $GLOBALS['DB']->executeQuery("SELECT * FROM " . $agws_it_recht_kanzlei_Tabelle. " WHERE " . $cWhere, 1);

                if (!is_object($agws_content_exists)) {
                    $oInsert = new stdClass();
                    $oInsert->kLink = intval($agws_it_recht_kanzlei_Link->kLink);
                    $oInsert->cSeo = getSeo("Impressum");
                    $oInsert->cISOSprache = gibSprachKeyISO("", $agws_it_recht_kanzlei_sprache->kSprache);
                    $oInsert->cName = "Impressum";
                    $oInsert->cTitle = "";
                    $oInsert->cContent = "";
                    $oInsert->cMetaTitle = "";
                    $oInsert->cMetaKeywords = "";
                    $oInsert->cMetaDescription = "";

                    ($agws_it_recht_kanzlei_shop4 === true)?
                        Shop::DB()->insertRow($agws_it_recht_kanzlei_Tabelle, $oInsert,1):
                        $GLOBALS['DB']->insertRow($agws_it_recht_kanzlei_Tabelle, $oInsert,1);

                    $oSeo           = new stdClass();
                    $oSeo->cSeo     = checkSeo($oInsert->cSeo);
                    $oSeo->kKey     = $oInsert->kLink;
                    $oSeo->cKey     = 'kLink';
                    $oSeo->kSprache = $agws_it_recht_kanzlei_sprache->kSprache;

                    ($agws_it_recht_kanzlei_shop4 === true)?
                        Shop::DB()->insert('tseo', $oSeo):
                        $GLOBALS['DB']->insert('tseo', $oSeo);
                }

                break;

            // Datenschutz
            case "datenschutz":
                $agws_it_recht_kanzlei_SpalteHtml    = "cContent";
                $agws_it_recht_kanzlei_SpalteText    = "";
                $agws_it_recht_kanzlei_Tabelle   = "tlinksprache";
                $agws_it_recht_kanzlei_Link      = ($agws_it_recht_kanzlei_shop4 === true) ? Shop::DB()->query("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_DATENSCHUTZ, 1) : $GLOBALS['DB']->executeQuery("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_DATENSCHUTZ, 1);
                $cWhere     = "cISOSprache = '" . gibSprachKeyISO("", $agws_it_recht_kanzlei_sprache->kSprache) . "' AND kLink = " . $agws_it_recht_kanzlei_Link->kLink;

                $agws_content_exists = ($agws_it_recht_kanzlei_shop4 === true)?
                    Shop::DB()->query("SELECT * FROM " . $agws_it_recht_kanzlei_Tabelle. " WHERE " . $cWhere, 1):
                    $GLOBALS['DB']->executeQuery("SELECT * FROM " . $agws_it_recht_kanzlei_Tabelle. " WHERE " . $cWhere, 1);

                if (!is_object($agws_content_exists)) {
                    $oInsert = new stdClass();
                    $oInsert->kLink = intval($agws_it_recht_kanzlei_Link->kLink);
                    $oInsert->cSeo = getSeo("Datenschutz");
                    $oInsert->cISOSprache = gibSprachKeyISO("", $agws_it_recht_kanzlei_sprache->kSprache);
                    $oInsert->cName = "Datenschutz";
                    $oInsert->cTitle = "";
                    $oInsert->cContent = "";
                    $oInsert->cMetaTitle = "";
                    $oInsert->cMetaKeywords = "";
                    $oInsert->cMetaDescription = "";

                    ($agws_it_recht_kanzlei_shop4 === true)?
                        Shop::DB()->insertRow($agws_it_recht_kanzlei_Tabelle, $oInsert,1):
                        $GLOBALS['DB']->insertRow($agws_it_recht_kanzlei_Tabelle, $oInsert,1);

                    $oSeo           = new stdClass();
                    $oSeo->cSeo     = checkSeo($oInsert->cSeo);
                    $oSeo->kKey     = $oInsert->kLink;
                    $oSeo->cKey     = 'kLink';
                    $oSeo->kSprache = $agws_it_recht_kanzlei_sprache->kSprache;

                    ($agws_it_recht_kanzlei_shop4 === true)?
                        Shop::DB()->insert('tseo', $oSeo):
                        $GLOBALS['DB']->insert('tseo', $oSeo);
                }

                break;
        }

		($agws_it_recht_kanzlei_shop4 === true) ?
			Shop::DB()->query("UPDATE " . $agws_it_recht_kanzlei_Tabelle. " SET " . $agws_it_recht_kanzlei_SpalteHtml . " = \"" . $agws_it_recht_kanzlei_ContentHtml . "\" WHERE " . $cWhere, 3):
			$GLOBALS['DB']->executeQuery("UPDATE " . $agws_it_recht_kanzlei_Tabelle. " SET " . $agws_it_recht_kanzlei_SpalteHtml . " = '" . $agws_it_recht_kanzlei_ContentHtml . "' WHERE " . $cWhere, 3);

        if ($agws_it_recht_kanzlei_SpalteText != "")
            ($agws_it_recht_kanzlei_shop4 === true) ?
				Shop::DB()->query("UPDATE " . $agws_it_recht_kanzlei_Tabelle. " SET " . $agws_it_recht_kanzlei_SpalteText . " = '" . $agws_it_recht_kanzlei_ContentText . "' WHERE " . $cWhere, 3):
				$GLOBALS['DB']->executeQuery("UPDATE " . $agws_it_recht_kanzlei_Tabelle. " SET " . $agws_it_recht_kanzlei_SpalteText . " = '" . $agws_it_recht_kanzlei_ContentText . "' WHERE " . $cWhere, 3);

        ($agws_it_recht_kanzlei_shop4 === true) ?
			Shop::DB()->query("INSERT INTO xplugin_agws_it_recht_kanzlei_tLog SET dLetzterPush = now(), cDokuArt = '" . $agws_it_recht_kanzlei_xml->rechtstext_type . "', cSprache = '" . $agws_it_recht_kanzlei_sprache->cISO . "', cStatus ='OK', cPDFName ='".$file_pdf_targetfilename_rename."'", 4):
			$GLOBALS['DB']->executeQuery("INSERT INTO xplugin_agws_it_recht_kanzlei_tLog SET dLetzterPush = now(), cDokuArt = '" . $agws_it_recht_kanzlei_xml->rechtstext_type . "', cSprache = '" . $agws_it_recht_kanzlei_sprache->cISO . "', cStatus ='OK', cPDFName ='".$file_pdf_targetfilename_rename."'", 4);

        // Logging systemlog - end
        Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Neuer Rechtstext gespeichert - Typ:  " . $agws_it_recht_kanzlei_xml->rechtstext_type, JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);
        agws_flush_template_cache($oPlugin);
        Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Templatecache geleert", JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);
        agws_flush_object_cache($oPlugin);
        Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Objectcache geleert", JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);
        //CACHING_GROUP_TEMPLATE

        return true;
    }

    // validate URL
    function agws_it_recht_kanzlei_url_valid($url, $limit_to_host = ''){
        // $limit_to_host is obsolete and remains as a parameter for compatibility reasons

        // check for allowed URLs
        if(
            (md5(md5(strtolower(substr($url, 0, 32)))) == 'e8d1c6ea05d248e381301ffff004c0d8') OR
            (md5(md5(strtolower(substr($url, 0, 33)))) == '43f82fb310c6c9f9d4f59a64e194252f') OR
            (strtolower(substr($url, 0, 31)) == 'http://www.it-recht-kanzlei.de/') OR
            (strtolower(substr($url, 0, 32)) == 'https://www.it-recht-kanzlei.de/')
        ){ return true; } else { return true; }
    }

    // check if a file is a pdf
    function agws_it_recht_kanzlei_check_if_pdf_file($filename){
        $handle = @fopen($filename, "r");
        $contents = @fread($handle, 4);
        @fclose($handle);
        if($contents == '%PDF'){ return true; } else { return false; }
    }

    function agws_it_recht_kanzlei_check_spezialseite($agws_it_recht_kanzlei_seite,$agws_it_recht_kanzlei_sprache,$agws_it_recht_kanzlei_shop4)
    {
        $agws_it_recht_kanzlei_Tabelle   = "tlinksprache";

        switch($agws_it_recht_kanzlei_seite)
        {
            // AGB
            case "agb":
                $agws_it_recht_kanzlei_Link      = ($agws_it_recht_kanzlei_shop4===true) ? Shop::DB()->query("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_AGB, 1) : $GLOBALS['DB']->executeQuery("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_AGB, 1);
                $cWhere     = "cISOSprache = '" . gibSprachKeyISO("", $agws_it_recht_kanzlei_sprache->kSprache) . "' AND kLink = " . $agws_it_recht_kanzlei_Link->kLink;
                break;

            // WRB
            case "widerruf":
                $agws_it_recht_kanzlei_Link      = ($agws_it_recht_kanzlei_shop4===true) ? Shop::DB()->query("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_WRB, 1) : $GLOBALS['DB']->executeQuery("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_WRB, 1);
                $cWhere     = "cISOSprache = '" . gibSprachKeyISO("", $agws_it_recht_kanzlei_sprache->kSprache) . "' AND kLink = " . $agws_it_recht_kanzlei_Link->kLink;
                break;

            // Impressum
            case "impressum":
                $agws_it_recht_kanzlei_Link      = ($agws_it_recht_kanzlei_shop4===true) ? Shop::DB()->query("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_IMPRESSUM, 1) : $GLOBALS['DB']->executeQuery("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_IMPRESSUM, 1);
                $cWhere     = "cISOSprache = '" . gibSprachKeyISO("", $agws_it_recht_kanzlei_sprache->kSprache) . "' AND kLink = " . $agws_it_recht_kanzlei_Link->kLink;
                break;

            // Datenschutz
            case "datenschutz":
                $agws_it_recht_kanzlei_Link      = ($agws_it_recht_kanzlei_shop4===true) ? Shop::DB()->query("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_DATENSCHUTZ, 1) : $GLOBALS['DB']->executeQuery("SELECT kLink FROM tlink WHERE nLinkart = " . LINKTYP_DATENSCHUTZ, 1);
                $cWhere     = "cISOSprache = '" . gibSprachKeyISO("", $agws_it_recht_kanzlei_sprache->kSprache) . "' AND kLink = " . $agws_it_recht_kanzlei_Link->kLink;
                break;
        }

        $checkSpezial = ($agws_it_recht_kanzlei_shop4===true) ? Shop::DB()->query("SELECT * FROM " . $agws_it_recht_kanzlei_Tabelle. " WHERE " . $cWhere, 1) : $GLOBALS['DB']->executeQuery("SELECT * FROM " . $agws_it_recht_kanzlei_Tabelle. " WHERE " . $cWhere, 1);

        if (isset($checkSpezial->kLink) && $checkSpezial->kLink > 0)
            return 1;

        return 0;
    }

    function agws_it_recht_kanzlei_pruefeVerzeichnisRechte($cVerzeichnis) {

        if (!defined('PFAD_ROOT'))
            return false;

        if (is_writable(PFAD_ROOT . $cVerzeichnis))
            return true;

        return false;
    }

    function agws_flush_template_cache($oPlugin)
    {
        // delete all template cachefiles
        $callback = function (array $pParameters) {
            if (!$pParameters['isdir']) {
                if (@unlink($pParameters['path'] . $pParameters['filename'])) {
                    $pParameters['count']++;
                } else {
                    Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Verzeichnis <strong>" . $pParameters['path'] . $pParameters['filename'] ."</strong> konnte nicht gel&ouml;scht werden!", JTLLOG_LEVEL_DEBUG, false, "kPlugin", $pParameters['oPlugin']->kPlugin);
                }
            } else {
                if (!@rmdir($pParameters['path'] . $pParameters['filename'])) {
                    Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Verzeichnis <strong>" . $pParameters['path'] . $pParameters['filename'] ."</strong> konnte nicht gel&ouml;scht werden!", JTLLOG_LEVEL_DEBUG, false, "kPlugin", $pParameters['oPlugin']->kPlugin);
                }
            }
        };
        $deleteCount  = 0;

        $cbParameters = [
            'count'  => &$deleteCount,
            'oPlugin' => $oPlugin
        ];
        $template    = Template::getInstance();
        $templateDir = $template->getDir();
        $dirMan      = new DirManager();
        $dirMan->getData(PFAD_ROOT . PFAD_COMPILEDIR . $templateDir, $callback, $cbParameters);
        $dirMan->getData(PFAD_ROOT . PFAD_ADMIN . PFAD_COMPILEDIR, $callback, $cbParameters);
    }

    function agws_flush_object_cache($oPlugin) {
        try {
            $cache = JTLCache::getInstance();
            $cache->setJtlCacheConfig();
        } catch (Exception $exc) {
            Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Fehler bei Initialisierung des Cache-Systems: <strong>" . $exc->getMessage() ."</strong>", JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);
            $error = 'Ausnahme: ' . $exc->getMessage();
        }

        $cache->flushTags(['core']);
    }