<?php
/**
 * Created by PhpStorm.
 * User: gerd
 * Date: 29.01.14
 * Time: 10:13
 */

/**Aufruf:
 * http://shopurl.tld/index.php?agws_it_recht_kanzlei=1
 **/

if ( verifyGPDataString('agws_it_recht_kanzlei') ==1 )
{
    require_once(PFAD_ROOT . PFAD_CLASSES . "class.JTL-Shop.Jtllog.php");
    require_once($oPlugin->cFrontendPfad  . "inc/func.agws_it_recht_kanzlei.php");
	require_once($oPlugin->cFrontendPfad  . "inc/class.agws_plugin_frontend.helper.php");

    $helper = agwsPluginFrontendHelper::getInstance($oPlugin);

    //Re-Validierung von oPlugin im Shop 4
    if ($helper->isShop4() === true)
        $oPlugin = new Plugin($oPlugin->kPlugin, true);

    // ----- Settings -----
    $agws_it_recht_kanzlei_local_api_version = '1.0';
    $agws_it_recht_kanzlei_local_supported_rechtstext_types = array('agb','datenschutz','widerruf','impressum');
    $agws_it_recht_kanzlei_local_supported_actions = array('push');
    $agws_it_recht_kanzlei_local_rechtstext_pdf_required = array('agb' => false);
    $agws_it_recht_kanzlei_local_dir_for_pdf_storage = PFAD_ROOT.'includes/plugins/agws_it_recht_kanzlei/version/pdf-dokumente/';
    $agws_it_recht_kanzlei_local_dir_for_pdf_storage_admin = PFAD_ROOT.PFAD_ADMIN.PFAD_INCLUDES.PFAD_EMAILPDFS;
    $agws_it_recht_kanzlei_local_limit_download_from_host = '';
    $agws_it_recht_kanzlei_pdf_dl = $oPlugin->oPluginEinstellungAssoc_arr['cPDFDown'];
    $agws_it_recht_kanzlei_pdf_mail = $oPlugin->oPluginEinstellungAssoc_arr['cPDFMail'];
    $agws_it_recht_kanzlei_local_user_auth_token = $oPlugin->oPluginEinstellungAssoc_arr['cAPIToken'];

    $agws_it_recht_kanzlei_post_xml = $_POST['xml'];

    if(phpversion() < "5.3")
    {
        if(get_magic_quotes_gpc())
            $agws_it_recht_kanzlei_post_xml = stripslashes($agws_it_recht_kanzlei_post_xml);
    }

    Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Rechtstext: " . $agws_it_recht_kanzlei_post_xml , JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);

    // Catch errors - no data sent
    if(trim($agws_it_recht_kanzlei_post_xml) == '')
        agws_it_recht_kanzlei_return_error('12',$oPlugin);

    // create xml object
    $agws_it_recht_kanzlei_xml = @simplexml_load_string($agws_it_recht_kanzlei_post_xml);

    // Catch errors - error creating xml object
    if($agws_it_recht_kanzlei_xml === false)
        agws_it_recht_kanzlei_return_error('12',$oPlugin);

    // Catch errors - action not supported
    if(($agws_it_recht_kanzlei_xml->action == '') OR (in_array($agws_it_recht_kanzlei_xml->action, $agws_it_recht_kanzlei_local_supported_actions) == false))
        agws_it_recht_kanzlei_return_error('10',$oPlugin);

    // Check api-version
    if($agws_it_recht_kanzlei_xml->api_version != $agws_it_recht_kanzlei_local_api_version)
        agws_it_recht_kanzlei_return_error('1',$oPlugin);

    // user authentication w token (alternative to auth username/password)
    if($agws_it_recht_kanzlei_xml->user_auth_token != $agws_it_recht_kanzlei_local_user_auth_token)
        agws_it_recht_kanzlei_return_error('3',$oPlugin);

    switch ($agws_it_recht_kanzlei_xml->action)
    {
        case 'push':

            // Catch errors - rechtstext_type
            if(($agws_it_recht_kanzlei_xml->rechtstext_type == '') OR (in_array($agws_it_recht_kanzlei_xml->rechtstext_type, $agws_it_recht_kanzlei_local_supported_rechtstext_types) == false))
                agws_it_recht_kanzlei_return_error('4',$oPlugin);

            // Catch errors - rechtstext_text
            if(strlen($agws_it_recht_kanzlei_xml->rechtstext_text) < 50)
                agws_it_recht_kanzlei_return_error('5',$oPlugin);

            // Catch errors - rechtstext_html
            if(strlen($agws_it_recht_kanzlei_xml->rechtstext_html) < 50)
                agws_it_recht_kanzlei_return_error('6',$oPlugin);

            $agws_it_recht_kanzlei_shop_lang = (string)$agws_it_recht_kanzlei_xml->rechtstext_language_iso639_2b;

			if ($helper->isShop4() === true)
			{
				$agws_it_recht_kanzlei_sprache = Shop::DB()->query("SELECT kSprache, cISO FROM tsprache WHERE cISO = '".$agws_it_recht_kanzlei_shop_lang."'", 1);
			} else 
			{
				$agws_it_recht_kanzlei_sprache = $GLOBALS['DB']->executeQuery("SELECT kSprache, cISO FROM tsprache WHERE cISO = '".$agws_it_recht_kanzlei_shop_lang."'", 1);
			}

            if (!isset($agws_it_recht_kanzlei_sprache->kSprache) || $agws_it_recht_kanzlei_sprache->kSprache <= 0) {
                Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Error - bermittelter Text nutzt Sprache die nicht im Shop aktiviert ist", JTLLOG_LEVEL_ERROR, false, "kPlugin", $oPlugin->kPlugin);
                agws_it_recht_kanzlei_return_error('9',$oPlugin);
            }

            //Download PDF-Files
            $file_pdf_target_rename = "-";

            if ($agws_it_recht_kanzlei_pdf_dl == 1 && $agws_it_recht_kanzlei_xml->rechtstext_type != 'impressum')
            {
                // Catch errors - element 'rechtstext_pdf_url' empty or URL invalid
                if(($agws_it_recht_kanzlei_xml->rechtstext_pdf_url == '') OR (agws_it_recht_kanzlei_url_valid($agws_it_recht_kanzlei_xml->rechtstext_pdf_url, $agws_it_recht_kanzlei_local_limit_download_from_host) !== true))
					agws_it_recht_kanzlei_return_error('7',$oPlugin);

                // Download pdf file
                $file_pdf_targetfilename = md5(uniqid("")).'.pdf'; // #### adapt the created filename to your needs, if required
                $file_pdf_target = $agws_it_recht_kanzlei_local_dir_for_pdf_storage.$file_pdf_targetfilename;
                $file_pdf_targetfilename_rename = $agws_it_recht_kanzlei_xml->rechtstext_type."-".$agws_it_recht_kanzlei_shop_lang."-".date("Ymd_His").".pdf";
                $file_pdf_target_rename = $agws_it_recht_kanzlei_local_dir_for_pdf_storage.$file_pdf_targetfilename_rename;

                $file_pdf = @fopen($file_pdf_target,"w+");
                if($file_pdf === false)
					agws_it_recht_kanzlei_return_error('7',$oPlugin); // catch errors

                //new in V200
                $file_content=http_get_contents($agws_it_recht_kanzlei_xml->rechtstext_pdf_url);
                if($file_content == "")
					agws_it_recht_kanzlei_return_error('7',$oPlugin); // catch errors
                
				$retval = @fwrite($file_pdf, $file_content);
                
                if($retval === false)
					agws_it_recht_kanzlei_return_error('7',$oPlugin); // catch errors
                
				$retval = @fclose($file_pdf);
                if($retval === false)
					agws_it_recht_kanzlei_return_error('7',$oPlugin); // catch errors

                // Catch errors - downloaded file was not properly saved
                if(file_exists($file_pdf_target) !== true)
					agws_it_recht_kanzlei_return_error('7',$oPlugin); 

                // verify that file is a pdf
                if(agws_it_recht_kanzlei_check_if_pdf_file($file_pdf_target) !== true)
				{
                    unlink($file_pdf_target);
                    agws_it_recht_kanzlei_return_error('7',$oPlugin);
                }

                // verify md5-hash, delete file if hash is not equal
                if(md5_file($file_pdf_target) != $agws_it_recht_kanzlei_xml->rechtstext_pdf_md5hash)
				{
                    unlink($file_pdf_target);
                    agws_it_recht_kanzlei_return_error('8',$oPlugin);
                }

                rename($file_pdf_target,$file_pdf_target_rename);

            }

            //Mail-Handling
			($helper->isShop4() === true) ?
				$agws_it_recht_kanzlei_MailID = Shop::DB()->query("SELECT kEmailvorlage FROM temailvorlage WHERE cModulId = '".MAILTEMPLATE_BESTELLBESTAETIGUNG."'", 1):
				$agws_it_recht_kanzlei_MailID = $GLOBALS['DB']->executeQuery("SELECT kEmailvorlage FROM temailvorlage WHERE cModulId = '".MAILTEMPLATE_BESTELLBESTAETIGUNG."'", 1);

            if ($agws_it_recht_kanzlei_pdf_mail > 0 && ($agws_it_recht_kanzlei_xml->rechtstext_type != 'impressum' && $agws_it_recht_kanzlei_xml->rechtstext_type != 'datenschutz') )
            {
                $file_pdf_targetfilename_copy_admin = $agws_it_recht_kanzlei_xml->rechtstext_type."_".$agws_it_recht_kanzlei_shop_lang.".pdf";
                $file_pdf_target_copy_admin = $agws_it_recht_kanzlei_local_dir_for_pdf_storage_admin.$file_pdf_targetfilename_copy_admin;

                if (!copy($file_pdf_target_rename, $file_pdf_target_copy_admin))
                   Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Error - PDF-Dokument Emailvorlage konnte nicht gespeichert werden", JTLLOG_LEVEL_ERROR, false, "kPlugin", $oPlugin->kPlugin);

                // Check if emailtemplate exists in choosen language -> if not create empty one
                $agws_emailvorlage_exists = ($helper->isShop4() === true)?
                    Shop::DB()->query("SELECT * FROM temailvorlagesprache WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 1):
                    $GLOBALS['DB']->executeQuery("SELECT * FROM temailvorlagesprache WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 1);

                if (!is_object($agws_emailvorlage_exists)) {
                    $oInsert = new stdClass();
                    $oInsert->kEmailvorlage = intval($agws_it_recht_kanzlei_MailID->kEmailvorlage);
                    $oInsert->kSprache = intval($agws_it_recht_kanzlei_sprache->kSprache);
                    $oInsert->cBetreff = "";
                    $oInsert->cContentHtml = "";
                    $oInsert->cContentText = "";
                    $oInsert->cPDFS = "";
                    $oInsert->cDateiname = "";

                    ($helper->isShop4() === true)?
                        Shop::DB()->insertRow('temailvorlagesprache', $oInsert):
                        $GLOBALS['DB']->insertRow('temailvorlagesprache', $oInsert);

                    Jtllog::writeLog("Plugin agws_it_recht_kanzlei - Debug - Emailvorlage fr Sprache '" . $agws_it_recht_kanzlei_sprache->cISO . "' erstellt", JTLLOG_LEVEL_DEBUG, false, "kPlugin", $oPlugin->kPlugin);
                }

                switch ($agws_it_recht_kanzlei_pdf_mail)
                {
                    case '1': //PDF-Datei

						$cPDFS_value = ";agb_".$agws_it_recht_kanzlei_shop_lang.".pdf;widerruf_".$agws_it_recht_kanzlei_shop_lang.".pdf;";
						$cDateiname_value = ";agb_doc;widerruf_doc;";

						if ($helper->isShop4() === true)
						{
							Shop::DB()->query("UPDATE temailvorlage SET nAGB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
							Shop::DB()->query("UPDATE temailvorlage SET nWRB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
							Shop::DB()->query("UPDATE temailvorlagesprache SET cPDFS = '".$cPDFS_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
							Shop::DB()->query("UPDATE temailvorlagesprache SET cDateiname = '".$cDateiname_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);							
						} else
						{
							$GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nAGB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
							$GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nWRB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
							$GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cPDFS = '".$cPDFS_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
							$GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cDateiname = '".$cDateiname_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);							
						}

                        break;

                    case '2': // Mail-Text

 						if ($helper->isShop4() === true)
						{
							Shop::DB()->query("UPDATE temailvorlage SET nAGB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
							Shop::DB()->query("UPDATE temailvorlage SET nWRB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
						} else
						{
							$GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nAGB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
							$GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nWRB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
						}

                        break;

                    case '3': // PDF-Datei & Mail-Text

                        $cPDFS_value = ";agb_".$agws_it_recht_kanzlei_shop_lang.".pdf;widerruf_".$agws_it_recht_kanzlei_shop_lang.".pdf;";
                        $cDateiname_value = ";agb_doc;widerruf_doc;";

 						if ($helper->isShop4() === true)
						{
							Shop::DB()->query("UPDATE temailvorlage SET nAGB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
							Shop::DB()->query("UPDATE temailvorlage SET nWRB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
							Shop::DB()->query("UPDATE temailvorlagesprache SET cPDFS = '".$cPDFS_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
							Shop::DB()->query("UPDATE temailvorlagesprache SET cDateiname = '".$cDateiname_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
						} else
						{
							$GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nAGB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
							$GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nWRB = '1' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
							$GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cPDFS = '".$cPDFS_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
							$GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cDateiname = '".$cDateiname_value."' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
						}

                        break;
                }


            }elseif ($agws_it_recht_kanzlei_pdf_mail == 0 && ($agws_it_recht_kanzlei_xml->rechtstext_type != 'impressum' || $agws_it_recht_kanzlei_xml->rechtstext_type != 'datenschutz') )
            {
				if ($helper->isShop4() === true)
				{
					Shop::DB()->query("UPDATE temailvorlage SET nAGB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
					Shop::DB()->query("UPDATE temailvorlage SET nWRB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
					Shop::DB()->query("UPDATE temailvorlagesprache SET cPDFS = '' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
					Shop::DB()->query("UPDATE temailvorlagesprache SET cDateiname = '' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
				} else
				{
					$GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nAGB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
					$GLOBALS['DB']->executeQuery("UPDATE temailvorlage SET nWRB = '0' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage, 10);
					$GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cPDFS = '' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
					$GLOBALS['DB']->executeQuery("UPDATE temailvorlagesprache SET cDateiname = '' WHERE kEmailvorlage = ".$agws_it_recht_kanzlei_MailID->kEmailvorlage." AND kSprache =".$agws_it_recht_kanzlei_sprache->kSprache, 10);
				}
            }

            $agws_it_recht_kanzlei_save = agws_it_recht_kanzlei_save($oPlugin,$agws_it_recht_kanzlei_xml,$agws_it_recht_kanzlei_sprache,$file_pdf_targetfilename_rename,$helper->isShop4());

            if ($agws_it_recht_kanzlei_save===true)
                 agws_it_recht_kanzlei_return_success('0',$oPlugin);

            break;

    }


    agws_it_recht_kanzlei_return_error('99',$oPlugin);
    exit();
}